//+------------------------------------------------------------------+
//| 3 ducks indicator      version 1                                 |
//|                                                                  |
//|      The indicator follows the rules of original 3 ducks system. |
//|      Indicator status is shown in the right upper corner of the  |
//|      chart. When all 3 timeframes have the same color, sell or   |
//|      buy.                                                        |
//|      Indicator also contains an audible alarm.                   |
//|      Indicator position in the window can be adjusted.           |
//|                                                                  |
//|                   by Rocroy, 3-22-2008                           |
//|                                                                  |
//+------------------------------------------------------------------+

#property indicator_chart_window

extern color ColorUpGood = Lime;
extern color ColorDownGood = Red;
extern int   Left_position = 0;
extern bool  SoundON=true;
extern int   Number_of_Alarms = 5;

static int   alertTag, alertcount;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorShortName("3 Ducks");
   alertcount = Number_of_Alarms;
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   ObjectsDeleteAll(0,OBJ_LABEL); 
   ObjectDelete("heading"); ObjectDelete("D1"); ObjectDelete("W1"); ObjectDelete("MN1"); 
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {    
    
    //d1 data
    double d1ma = iMA(NULL,PERIOD_D1,12,0,MODE_SMA,PRICE_CLOSE,0);

    //w1 data
    double w1ma = iMA(NULL,PERIOD_W1,12,0,MODE_SMA,PRICE_CLOSE,0);

    //mn1 data
    double mn1ma = iMA(NULL,PERIOD_MN1,12,0,MODE_SMA,PRICE_CLOSE,0);
    
    //define color
    color color_d1, color_w1, color_mn1;
    
    //define string
    string arrow_d1, arrow_w1, arrow_mn1;
        

    //d1 up trend
    if (d1ma < Bid ) { color_d1 = ColorUpGood; }
    
    //d1 down trend
    if (d1ma > Bid ) { color_d1 = ColorDownGood; }

    //w1 up trend
    if (w1ma < Bid ) { color_w1 = ColorUpGood; }
    
    //w1 down trend
    if (w1ma > Bid ) { color_w1 = ColorDownGood; }

    //mn1 up trend
    if (mn1ma < Bid ) { color_mn1 = ColorUpGood; }
    
    //mn1 down trend
    if (mn1ma > Bid ) { color_mn1 = ColorDownGood; }
    
    
    //Heading           
    ObjectCreate("heading", OBJ_LABEL, 0, 0, 0);
        ObjectSetText("heading","12 SMA",12, "Arial Bold", color_d1);
        ObjectSet("heading", OBJPROP_XDISTANCE, 923+Left_position);
        ObjectSet("heading", OBJPROP_YDISTANCE, 686);
        
    //Signal Labels           
    ObjectCreate("D1", OBJ_LABEL, 0, 0, 0);//D1 SIGNAL
        ObjectSetText("D1","D1",12, "Arial Bold", color_d1);
        ObjectSet("D1", OBJPROP_XDISTANCE, 890+Left_position);
        ObjectSet("D1", OBJPROP_YDISTANCE, 718);
        
    ObjectCreate("W1", OBJ_LABEL, 0, 0, 0);//W1 SIGNAL
        ObjectSetText("W1","W1",12, "Arial Bold", color_w1);
        ObjectSet("W1", OBJPROP_CORNER, 0);
        ObjectSet("W1", OBJPROP_XDISTANCE, 942+Left_position);
        ObjectSet("W1", OBJPROP_YDISTANCE, 718);
        
    ObjectCreate("MN1", OBJ_LABEL, 0, 0, 0);//MN1 SIGNAL
        ObjectSetText("MN1","MN1",12, "Arial Bold", color_mn1);
        ObjectSet("MN1", OBJPROP_CORNER, 0);
        ObjectSet("MN1", OBJPROP_XDISTANCE, 990+Left_position);
        ObjectSet("MN1", OBJPROP_YDISTANCE, 718);

   
      if (d1ma < Bid) { arrow_d1 = "5"; }
      if (d1ma > Bid) { arrow_d1 = "6"; }

      if (w1ma < Bid) { arrow_w1 = "5"; }
      if (w1ma > Bid) { arrow_w1 = "6"; }

      if (mn1ma < Bid) { arrow_mn1 = "5"; }
      if (mn1ma > Bid) { arrow_mn1 = "6"; }

      
      //arrow d1
      ObjectCreate("ObjLabel9a", OBJ_LABEL, 0, 0, 0);
        ObjectSetText("ObjLabel9a",arrow_d1,16, "Webdings", color_d1);
        ObjectSet("ObjLabel9a", OBJPROP_XDISTANCE, 890+Left_position);
        ObjectSet("ObjLabel9a", OBJPROP_YDISTANCE, 738);
        
      //arrow w1
      ObjectCreate("ObjLabel10a", OBJ_LABEL, 0, 0, 0);
        ObjectSetText("ObjLabel10a",arrow_w1,16, "Webdings", color_w1);
        ObjectSet("ObjLabel10a", OBJPROP_XDISTANCE, 944+Left_position);
        ObjectSet("ObjLabel10a", OBJPROP_YDISTANCE, 738);
    
      //arrow mn1
      ObjectCreate("ObjLabel11a", OBJ_LABEL, 0, 0, 0);
        ObjectSetText("ObjLabel11a",arrow_mn1,16, "Webdings", color_mn1);
        ObjectSet("ObjLabel11a", OBJPROP_XDISTANCE, 994+Left_position);
        ObjectSet("ObjLabel11a", OBJPROP_YDISTANCE, 738);        
        
// alarms
      
      if ( color_d1 != color_w1 || color_mn1 != color_mn1 ) alertcount = Number_of_Alarms;
      
      if (SoundON==true && color_d1 == color_d1 && color_d1 == color_mn1 &&
         alertcount>0 && alertTag!=TimeMinute(TimeCurrent()) )
      {
         Alert(" 3 Ducks in a row! ",Symbol());
         alertTag = TimeMinute(TimeCurrent());
         if (alertcount > 0) alertcount--;
      }
      
        
//----
    return(0); 
//----
} 

//+------------------------------------------------------------------+